#
# Output.tcl
#
# Output channel
#

class Output {
  
  import Indent;

  staticfield fd;
  staticfield width 75;

  rename open _open;
  rename close _close;

  staticmethod open {name} {
    set fd [_open $name w];
  }

  staticmethod close {} {
    _close $fd;
    set fd {};
  }

  staticmethod print {str} {
    set lines [split $str "\n"];
    foreach line $lines {
      puts $fd "[Indent get]$line";
    }
  }

  staticmethod newline {} {
    puts $fd "";
  }

  staticmethod printText {str} {
    set Indent [Indent get];
    set max [expr $width - [string length $Indent]];
    set lines [split $str "\n"];
    foreach line $lines {
      set len [string length $line];
      if { $len < $max } {
         puts $fd "$Indent$line";
         continue;
      }

      while { $len > 0 } {
        if { $len > $max } {
          set len [string wordstart $line $max];
        }
	puts $fd "$Indent[string range $line 0 [expr $len - 1]]";
        set line [string range $line $len end];
        set len [string length $line];
      }
    }
  }
 
  staticmethod verbatim {str} {
    puts -nonewline $fd $str;
  }
}
