/* ****************** Bean property **********************/\n

${static}${visibility}${transient}${volatile}boolean ${name}${initialvalue};

private final PropertyChangeSupport ${name}_changes = 
  new PropertyChangeSupport(this);

private final VetoableChangeSupport ${name}_vetos = 
  new VetoableChangeSupport(this);


/**
 * Asks for a permission to change the value of the vetoable property
 * \"${name}\" from all registered listeners with a veto priviledge.
 * If granted a permission, sets the value of property \"${name}\"
 * and informs all listeners 
 */
public void set${Name}(boolean value) {
  $type oldvalue = this.${name};
  return "${name}_vetos.firePropertyChange(\"${name}\", 
                                 new Boolean(oldvalue), 
                                 new Boolean(value));"
  this.${name} = value;
  return "${name}_changes.firePropertyChange(\"${name}\", 
                                   new Boolean(oldvalue), 
                                   new Boolean(value));"
}

/**
 * Gets the value of property \"${name}\"
 */
public boolean is${Name}() {
  return this.${name};
}

/**
 * Registers a listener for property \"${name}\"
 */
public void add${Name}ChangeListener(PropertyChangeListener l) {
  ${name}_changes.addPropertyChangeListener(l);
}

/**
 * Removes a listener registered for property \"${name}\"
 */
public void remove${Name}ChangeListener(PropertyChangeListener l) {
  ${name}_changes.removePropertyChangeListener(l);
}

/**
 * Registers a listener with a veto priviledge for property \"${name}\".
 * Listeners with this priviledge are always PropertyChangeListeners as well.
 */
public void addVetoable${Name}ChangeListener(VetoableChangeListener l) {
  ${name}_changes.addVetoableChangeListener(l);
  ${name}_changes.addPropertyChangeListener(l);
}

/**
 * Removes a listener registered with a veto priviledge for
 * property \"${name}\"
 */
public void removeVetoable${Name}ChangeListener(VetoableChangeListener l) {
  ${name}_changes.removeVetoableChangeListener(l);
  ${name}_changes.removePropertyChangeListener(l);
}\n

/* ************** End of Bean property *******************/\n
