/* ****************** Bean property **********************/\n

${static}${visibility}${transient}${volatile}${type} ${name}${initialvalue};

private final PropertyChangeSupport ${name}_changes = 
  new PropertyChangeSupport(this);

private final VetoableChangeSupport ${name}_vetos = 
  new VetoableChangeSupport(this);

/**
 * Asks for a permission to change the value of the vetoable property
 * \"${name}\" from all registered listeners with a veto priviledge.
 * If granted a permission, sets the value of property \"${name}\"
 * and informs all listeners 
 */
public void set${Name}($type value) {
  $type oldvalue = this.${name};
  [if { $type != $Type } {
     return "${name}_vetos.fireVetoableChange(\"${name}\", 
                                   new ${Type}(oldvalue), 
                                   new ${Type}(value));" } else {
     return "${name}_vetos.fireVetoableChange(\"${name}\", oldvalue, value));"
   }]
  this.${name} = value;
  [if { $type != $Type } {
     return "${name}_changes.firePropertyChange(\"${name}\", 
                                     new ${Type}(oldvalue), 
                                     new ${Type}(value));" } else {
     return "${name}_changes.firePropertyChange(\"${name}\", 
                                     oldvalue, 
                                     value));"
   }]
}

/**
 * Gets the value of property \"${name}\"
 */
public ${type} get${Name}() {
  return this.${name};
}

/**
 * Registers a listener for property \"${name}\"
 */
public void add${Name}ChangeListener(PropertyChangeListener l) {
  ${name}_changes.addPropertyChangeListener(l);
}

/**
 * Removes a listener registered for property \"${name}\"
 */
public void remove${Name}ChangeListener(PropertyChangeListener l) {
  ${name}_changes.removePropertyChangeListener(l);
}

/**
 * Registers a listener with a veto priviledge for property \"${name}\".
 * Listeners with this priviledge are always PropertyChangeListeners as well.
 */
public void addVetoable${Name}ChangeListener(VetoableChangeListener l) {
  ${name}_changes.addVetoableChangeListener(l);
}

/**
 * Removes a listener registered with a veto priviledge for
 * property \"${name}\"
 */
public void removeVetoable${Name}ChangeListener(VetoableChangeListener l) {
  ${name}_changes.removeVetoableChangeListener(l);
}\n

/* ************** End of Bean property *******************/\n
