
source [file join .. TclClass.tcl];
source [file join .. TclDecorator.tcl];
source [file join .. Indent.tcl];
source [file join .. Output.tcl];
source [file join .. Console.tcl];
source [file join .. Expander.tcl];

source [file join .. Comment.tcl];
source [file join .. Section.tcl];
source [file join .. Element.tcl];
source [file join .. Attribute.tcl];
source [file join .. Operation.tcl];
source [file join .. Role.tcl];
source [file join .. Class.tcl]; 

interp alias {} SimpleClass {} Class;

set model [sc_getActiveModel]
set interface [sc_getActiveObjectInterface]
$model unmark_tree
$interface mark_selected_objects

set classes [$model get marked_objects "Class"]

sc_clearConsole;

class Test {

  import Console;

  staticmethod main {classes} {
    set o [new Class [lindex $classes 0]];

    Console message "class = $o";
    Console message "interfaces = [$o interfaces]";
    Console message "superclass = [$o superclass]";
    Console message "superclass = [$o superclasses]";

    $o print;
  }

}

Output open "tClass.out";
Test main $classes;
Output close;
