
source "[file join .. TclClass.tcl]"

class Test1 {

  field field "field";
  staticfield staticfield "static field";
  staticarray staticarray;
  
  method method1 {arg1 arg2} {
    if { $field != "field" } { error "Failed." }
    if { $arg1  != "arg1"  } { error "Failed." }
    if { $arg2  != "arg2"  } { error "Failed." }
  }

  staticmethod staticmethod1 {arg1 arg2} {
    if { $staticfield != "static field" } { error "Failed." }
    if { $arg1  != "arg1"  } { error "Failed." }
    if { $arg2  != "arg2"  } { error "Failed." }
  }

  set o [new Test1];

  if { $o != "Test1_1" } { error "Failed." }

  $o method1 arg1 arg2;
  staticmethod1 arg1 arg2;

  delete $o;

  set o [new Test1];

  if { $o != "Test1_2" } { error "Failed." }

  $o method1 arg1 arg2;
  staticmethod1 arg1 arg2;
}

class Test2 {

  extends Test1;

  set o [new Test2];

  if { $o != "Test2_1" } { error "Failed." }

  $o method1 arg1 arg2;
  staticmethod1 arg1 arg2;

  delete $o;

  set o [new Test2];

  if { $o != "Test2_2" } { error "Failed." }

  $o method1 arg1 arg2;
  staticmethod1 arg1 arg2;
}

