/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Accessor
  Package: conduits
  File:    Accessor.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Accessor
  
  Accessor defines an abstract interface for the Mux to obtain and 
  encapsulate Muxing information on Messages.
*/
public interface Accessor {

  /**
    Extracts or decodes a key value from a message for demultiplexing. 
    Called by Mux.mux when a message has arrived from side A, and should be 
    routed through side B.
  */
  public abstract Object getKey(Message message);
  
  
  
  
  /**
    Encodes or attaches demultiplexing information to a Message. Called by 
    Mux.mux when a message traverses from some side B towards side A. The 
    key is the particular key value attached to the Conduit the message is 
    arriving from.
  */
  public abstract void setKey(Message message, Object key);
  
  
  
  
  /**
  */
  public abstract void unsetKey(Message message);
  
  
  
  
} // Accessor


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
