/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  BinaryMessenger
  Package: conduits
  File:    BinaryMessenger.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  BinaryMessenger
  
  
*/
public abstract class BinaryMessenger
  extends Object
  implements Messenger {

  /**
  */
  public int getLength(Object arrayRef) {
  
    //+ BinaryMessenger::getLength(Object)
    return ((byte[])arrayRef).length;
    //- BinaryMessenger::getLength(Object)
  }
  
  
  /**
  */
  public int getByte(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getByte(Object, int)
    return ((byte[])arrayRef)[index];
    //- BinaryMessenger::getByte(Object, int)
  }
  
  
  /**
  */
  public void setByte(Object arrayRef, int index, byte value) {
  
    //+ BinaryMessenger::setByte(Object, int, byte)
    ((byte[])arrayRef)[index] = value;
    //- BinaryMessenger::setByte(Object, int, byte)
  }
  
  
  /**
  */
  public int getShort(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getShort(Object, int)
    return ((((int)((byte[])arrayRef)[index * 2 + 0]) & 0xff) << 8)
         | ((((int)((byte[])arrayRef)[index * 2 + 1]) & 0xff) << 0);
    //- BinaryMessenger::getShort(Object, int)
  }
  
  
  /**
  */
  public void setShort(Object arrayRef, int index, short value) {
  
    //+ BinaryMessenger::setShort(Object, int, short)
    ((byte[])arrayRef)[index * 2 + 0] = (byte)(value >> 8);
    ((byte[])arrayRef)[index * 2 + 1] = (byte)(value >> 0);
    //- BinaryMessenger::setShort(Object, int, short)
  }
  
  
  /**
  */
  public int getInt(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getInt(Object, int)
    return ((((int)((byte[])arrayRef)[index * 4 + 0]) & 0xff) << 24)
    	 | ((((int)((byte[])arrayRef)[index * 4 + 1]) & 0xff) << 16)
    	 | ((((int)((byte[])arrayRef)[index * 4 + 2]) & 0xff) <<  8)
    	 | ((((int)((byte[])arrayRef)[index * 4 + 3]) & 0xff) <<  0);
    //- BinaryMessenger::getInt(Object, int)
  }
  
  
  /**
  */
  public void setInt(Object arrayRef, int index, int value) {
  
    //+ BinaryMessenger::setInt(Object, int, int)
    ((byte[])arrayRef)[index * 4 + 0] = (byte)(value >> 24);
    ((byte[])arrayRef)[index * 4 + 1] = (byte)(value >> 16);
    ((byte[])arrayRef)[index * 4 + 2] = (byte)(value >>  8);
    ((byte[])arrayRef)[index * 4 + 3] = (byte)(value >>  0);
    //- BinaryMessenger::setInt(Object, int, int)
  }
  
  
  /**
  */
  public long getLong(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getLong(Object, int)
    return ((((int)((byte[])arrayRef)[index * 8 + 0]) & 0xff) << 56)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 1]) & 0xff) << 48)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 2]) & 0xff) << 40)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 3]) & 0xff) << 32)
         | ((((int)((byte[])arrayRef)[index * 8 + 4]) & 0xff) << 24)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 5]) & 0xff) << 16)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 6]) & 0xff) <<  8)
    	 | ((((int)((byte[])arrayRef)[index * 8 + 7]) & 0xff) <<  0);
    //- BinaryMessenger::getLong(Object, int)
  }
  
  
  /**
  */
  public void setLong(Object arrayRef, int index, long value) {
  
    //+ BinaryMessenger::setLong(Object, int, long)
    ((byte[])arrayRef)[index * 8 + 0] = (byte)(value >> 56);
    ((byte[])arrayRef)[index * 8 + 1] = (byte)(value >> 48);
    ((byte[])arrayRef)[index * 8 + 2] = (byte)(value >> 40);
    ((byte[])arrayRef)[index * 8 + 3] = (byte)(value >> 32);
    ((byte[])arrayRef)[index * 8 + 4] = (byte)(value >> 24);
    ((byte[])arrayRef)[index * 8 + 5] = (byte)(value >> 16);
    ((byte[])arrayRef)[index * 8 + 6] = (byte)(value >>  8);
    ((byte[])arrayRef)[index * 8 + 7] = (byte)(value >>  0);
    //- BinaryMessenger::setLong(Object, int, long)
  }
  
  
  /**
  */
  public float getFloat(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getFloat(Object, int)
    throw new NoSuchMethodError("unimplemented");
    //- BinaryMessenger::getFloat(Object, int)
  }
  
  
  /**
  */
  public void setFloat(Object arrayRef, int index, float value) {
  
    //+ BinaryMessenger::setFloat(Object, int, float)
    throw new NoSuchMethodError("unimplemented");
    //- BinaryMessenger::setFloat(Object, int, float)
  }
  
  
  /**
  */
  public double getDouble(Object arrayRef, int index) {
  
    //+ BinaryMessenger::getDouble(Object, int)
    throw new NoSuchMethodError("unimplemented");
    //- BinaryMessenger::getDouble(Object, int)
  }
  
  
  /**
  */
  public void setDouble(Object arrayRef, int index, double value) {
  
    //+ BinaryMessenger::setDouble(Object, int, double)
    throw new NoSuchMethodError("unimplemented");
    //- BinaryMessenger::setDouble(Object, int, double)
  }
  
  
} // BinaryMessenger


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
