/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  InstallOob
  Package: conduits
  File:    InstallOob.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  InstallOob
  
  
*/
public final class InstallOob
  extends Object
  implements OutOfBand {

  /**
  */
  private Side[] endpoints;
  
  /**
  */
  private Conduit prototype;
  
  /**
  */
  public InstallOob(Side[] endpoints, Conduit proto) {
  
    //+ InstallOob::InstallOob(Side[], Conduit)
    if (endpoints == null)
      throw new IllegalArgumentException("endpoints can't be null; empty array is ok");
    this.endpoints = endpoints;
    this.prototype = proto;
    //- InstallOob::InstallOob(Side[], Conduit)
  }
  
  
  /**
  */
  public int getEndpointCount() {
  
    //+ InstallOob::getEndpointCount( )
    return endpoints.length;
    //- InstallOob::getEndpointCount( )
  }
  
  
  /**
  */
  public Side getEndpoint(int index) {
  
    //+ InstallOob::getEndpoint(int)
    return endpoints[index];
    //- InstallOob::getEndpoint(int)
  }
  
  
  /**
  */
  public void setEndpointCount(int count) {
  
    //+ InstallOob::setEndpointCount(int)
    Side[] newEndpoints = new Side[count];
    System.arraycopy(endpoints, 0, newEndpoints, 0, 
                     endpoints.length > count? count: endpoints.length);
    endpoints = newEndpoints;
    //- InstallOob::setEndpointCount(int)
  }
  
  
  /**
  */
  public void setEndpoint(int index, Side endpoint) {
  
    //+ InstallOob::setEndpoint(int, Side)
    endpoints[index] = endpoint;
    //- InstallOob::setEndpoint(int, Side)
  }
  
  
  /**
  */
  public Conduit getPrototype() {
  
    //+ InstallOob::getPrototype( )
    return prototype;
    //- InstallOob::getPrototype( )
  }
  
  
  /**
  */
  public void setPrototype(Conduit protot) {
  
    //+ InstallOob::setPrototype(Conduit)
    prototype = protot;
    //- InstallOob::setPrototype(Conduit)
  }
  
  
} // InstallOob


