/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Installer
  Package: conduits
  File:    Installer.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Installer
  
  
*/
public final class Installer
  extends Object
  implements InstallMessenger, Messenger {

  /**
  */
  public static final Installer instance = new Installer();
  
  /**
  */
  private Installer() {
  
    //+ Installer::Installer( )
    //- Installer::Installer( )
  }
  
  
  /**
  */
  public Side getEndpoint(Message message, int index) {
  
    //+ Installer::getEndpoint(Message, int)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getEndpoint(index);
    //- Installer::getEndpoint(Message, int)
  }
  
  
  /**
  */
  public int getEndpointCount(Message message) {
  
    //+ Installer::getEndpointCount(Message)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getEndpointCount();
    //- Installer::getEndpointCount(Message)
  }
  
  
  /**
  */
  public Conduit getPrototype(Message message) {
  
    //+ Installer::getPrototype(Message)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getPrototype();
    //- Installer::getPrototype(Message)
  }
  
  
  /**
  */
  public void apply(Message message, State state, Session session) {
  
    //+ Installer::apply(Message, State, Session)
    // Do nothing
    //- Installer::apply(Message, State, Session)
  }
  
  
} // Installer


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
