/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Messenger
  Package: conduits
  File:    Messenger.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Messenger
  
  Messengers are used to interpret Messages. In a way, their relaitionship 
  to Messages is similar to that of States' relationship to Sessions. All 
  Messengers should be Singletons, and contain no internal state. A single 
  Messenger may be attached to several Messages.
*/
public interface Messenger {

  /**
  */
  public static Messenger instance = null;
  
  /**
  */
  public abstract void apply(Message message, State state, Session session);
  
  
  
  
} // Messenger


