/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Timeout
  Package: conduits
  File:    Timeout.java
*/
package fi.hut.tcm.jacob.conduits;
import fi.hut.tcm.jacob.utility.Storage;
import fi.hut.tcm.jacob.utility.Pool;
import fi.hut.tcm.jacob.conduits.TimerThread;
/**
  Timeout
  
  
*/
public final class Timeout
  extends MessageTransporter {

  /**
  */
  long expirytime;
  
  /**
  */
  Timeout() {
  
    //+ Timeout::Timeout( )
    super();
    expirytime = 0;
    //- Timeout::Timeout( )
  }
  
  
  /**
    Creates a new Timeout and schedules it by calling <code>timerThread.
    schedule</code>.
  */
  protected static Timeout newTimeout(Side at, Message message, long timeout) {
  
    //+ Timeout::newTimeout(Side, Message, long)
    Timeout t;
    t = (Timeout)TimeoutFactory.instance.newObject();
    t.init(at, message, timeout);
    return t;
    //- Timeout::newTimeout(Side, Message, long)
  }
  
  
  /**
  */
  protected void init(Side at, Message message, long timeout) {
  
    //+ Timeout::init(Side, Message, long)
    setMessage(message);
    setNext(at);
    this.expirytime = timeout;
    this.init();
    //- Timeout::init(Side, Message, long)
  }
  
  
  /**
  */
  void init() {
  
    //+ Timeout::init( )
    TimerThread.instance.schedule(this);
    //- Timeout::init( )
  }
  
  
  /**
  */
  protected void reset() {
  
    //+ Timeout::reset( )
    this.cancel();
    this.init();
    //- Timeout::reset( )
  }
  
  
  /**
  */
  protected void finalize() {
  
    //+ Timeout::finalize( )
    TimeoutFactory.instance.releaseObject(this);
    //- Timeout::finalize( )
  }
  
  
  /**
  */
  protected void cancel() {
  
    //+ Timeout::cancel( )
    TimerThread.instance.cancel(this);
    //- Timeout::cancel( )
  }
  
  
} // Timeout


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
