/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  TimeoutQuery
  Package: conduits
  File:    TimeoutQuery.java
*/
package fi.hut.tcm.jacob.conduits;
import fi.hut.tcm.jacob.utility.OrderQuery;
/**
  TimeoutQuery
  
  Used internally by TimerThread's OrderedQueue to find out the relative 
  order of Timeouts.
  XXX This class should be package local, but cannot be quite yet.
*/
class TimeoutQuery
  extends Object
  implements OrderQuery {

  /**
  */
  public static TimeoutQuery instance = new TimeoutQuery();
  
  /**
  */
  private TimeoutQuery() {
  
    //+ TimeoutQuery::TimeoutQuery( )
    //- TimeoutQuery::TimeoutQuery( )
  }
  
  
  /**
  */
  public long getOrderKey(Object timeout) {
  
    //+ TimeoutQuery::getOrderKey(Object)
    if (timeout instanceof Timeout) {
      return ((Timeout)timeout).expirytime;
    } else {
      return 0;  // XXX: Is this a sane value?
    }
    //- TimeoutQuery::getOrderKey(Object)
  }
  
  
} // TimeoutQuery


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
