/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  TravellerThread
  Package: conduits
  File:    TravellerThread.java
*/
package fi.hut.tcm.jacob.conduits;
import fi.hut.tcm.jacob.utility.Queue;
import java.lang.Thread;
/**
  TravellerThread
  
  TravellerThread  takes Runnable Visitor from Scheduler and calls its run(
   ).
*/
final class TravellerThread
  extends Thread {

  /**
  */
  private Queue schedulerQueue;
  
  /**
    The constructor of the TravelerThread.
  */
  public TravellerThread(Queue schedulerQueue) {
  
    //+ TravellerThread::TravellerThread(Queue)
    this.schedulerQueue = schedulerQueue;
    //- TravellerThread::TravellerThread(Queue)
  }
  
  
  /**
  */
  public void run() {
  
    //+ TravellerThread::run( )
    Runnable visitor;

    System.out.println("TravellerThread started, running visitor...");
    while ((visitor = (Runnable)schedulerQueue.take()) != null) {
      visitor.run();
    }
    System.out.println("TravellerThread done.");
    //- TravellerThread::run( )
  }
  
  
} // TravellerThread


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
