/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Visitor
  Package: conduits
  File:    Visitor.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Visitor
  
  A visitor is an abstract interface that allows Transporters and other 
  classes to traverse the conduit graph. Whenever someone calls a conduit's
   accept() method handing it a visitor, the conduit indicates its specific
   type by calling an appropriate at() method of the visiting visitor.
*/
public interface Visitor
  extends Runnable {

  /**
  */
  public abstract void at(Mux mux, Side at);
  
  
  
  
  /**
  */
  public abstract void at(Session session, Side at);
  
  
  
  
  /**
  */
  public abstract void at(ConduitFactory factory, Side at);
  
  
  
  
  /**
  */
  public abstract void at(Adaptor adaptor, Side at);
  
  
  
  
} // Visitor


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
