
package fi.hut.tcm.jacob.tests;

import fi.hut.tcm.jacob.utility.*;
import fi.hut.tcm.jacob.conduits.*;

public class T1  {
  public static void main(String[] args) {
    T t = new T() {
      public void t() {
        System.out.println(this.getClass().getName() + ": start");
        // Test calls
        queueTest();
        orderedQueueTest();
        // End of test calls
        System.out.println(this.getClass().getName() + ": end");
      }
      // Test themselves
      private void queueTest() {
        Queue q;
        
        q = new Queue();
        assert(q.empty());
        assert(!q.full());
 
 	q.put(new Integer(1));
 	assert(!q.empty());
 	assert(!q.full());
 	
 	Object o = q.take();
 	assert(o instanceof Integer);
 	assert(o.equals(new Integer(1)));
 	assert(q.empty());
 	
	Integer i1, i2, i3;
 	q.put(i1 = new Integer(1));
 	q.put(i2 = new Integer(2));
 	q.put(i3 = new Integer(3));
 	assert(!q.empty());
 	assert(!q.full());
 	
 	Object o1 = q.take();
 	assert(!q.empty());
 	Object o2 = q.take();
 	assert(!q.empty());
 	Object o3 = q.take();
 	assert(q.empty());
 	
 	assert(i1 == o1);
 	assert(i2 == o2);
 	assert(i3 == o3);
      }
      
      private void orderedQueueTest() {
        OrderedQueue q;
        
        q = new OrderedQueue(new OrderQuery() {
                               public long getOrderKey(Object o) {
                                 return ((Number)o).longValue();
                               }
                             });
        
        assert(q.empty());
        assert(!q.full());
        
 	q.put(new Integer(1));
 	assert(!q.empty());
 	assert(!q.full());
 	
 	Object o = q.take();
 	assert(o instanceof Integer);
 	assert(o.equals(new Integer(1)));
 	assert(q.empty());
 	
	Integer i1, i2, i3;
 	q.put(i2 = new Integer(-2));
 	q.put(i1 = new Integer(-1));
 	q.put(i3 = new Integer(-3));
 	assert(!q.empty());
 	assert(!q.full());
 	
 	Object o1 = q.take();
 	assert(!q.empty());
 	Object o2 = q.take();
 	assert(!q.empty());
 	Object o3 = q.take();
 	assert(q.empty());
 	
 	assert(i1 == o1);
 	assert(i2 == o2);
 	assert(i3 == o3);
      } 
        
      // End of tests
      private void assert(boolean b) {
        if (b) return;
        System.out.println("Test failed.");
        throw new InternalError("Test failed");
      } 
    };
    t.t();
  }
}