
package fi.hut.tcm.jacob.tests;

import fi.hut.tcm.jacob.utility.*;
import fi.hut.tcm.jacob.conduits.*;

public class T2 {
  static Messenger mr = new Messenger() {
    public void apply(Message m, State s, Session se) {
      System.out.println("Messenger: applying " + m + " on state " + s +
                         "in session " + se);
    }
  };
  
  public static void main(String[] args) {
    T t = new T() {
      public void t() {
        System.out.println(this.getClass().getName() + ": start");
        // Test calls
        t1();
        t2();
        t3();
        // End of test calls
        System.out.println(this.getClass().getName() + ": end");
      }
      // Tests themselves
      private void t1() {
        MyAdaptor adaptor = new MyAdaptor();
    
        Message m = adaptor.newMessage(null, mr, null);
        
        adaptor.adapt(m);
      }
      
      private void t2() {
        MyAdaptor a1 = null, a2 = null;
        try {
          a1 = new MyAdaptor();
          a2 = new MyAdaptor();
        
          a1.getSide(Side.A).attach(a2.getSide(Side.A));
          Message m = a1.newMessage(null, mr, null);
          MessageTransporter mt = a1.newMT(m);
          a1.getSide(Side.A).accept(mt);
        } catch (Exception e) {
          System.out.println("Exception" + e);
          e.printStackTrace();
          assert(false);
        }
      }
      
      private void t3() {
      }
      // End of tests
      private void assert(boolean b) {
        if (b) return;
        System.out.println("Test failed.");
        throw new InternalError("Test failed");
      } 
    };
    t.t();
  

  }
  

}

class MyAdaptor extends Adaptor {
  public void adapt(Message m) {
    System.out.println("Adaptor: adapting " + m);
  }
  public Message newMessage(Object contents, Messenger messenger, OutOfBand oob) {
    return super.newMessage(contents, messenger, oob);
  }
  public MessageTransporter newMT(Message m) {
    return super.newMessageTransporter(m);
  }
}