/**

    File:    IcmpEchoTest.java

    !!!!!!!!HANDMADE!!!!!!!

*/

// package fi.hut.tcm.jacob.tcpip.icmp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;
/**

  IcmpEchoTest

*/

public class IcmpEchoTest {
  
  // SimpleScheduler automatically starts travellerThread
  private final SimpleScheduler scheduler = SimpleScheduler.instance;
  
  public static void main(String[] argv) {

    if (argv.length != 0) {
      System.err.println("Usage: java IcmpEchoTest");
      System.exit(1);
    }

    IpAddress myAddr = new IpAddress("1.2.3.4");
    int myIpAddr = myAddr.toInt();

    IpAddress otherAddr = new IpAddress("10.0.10.20");
    int otherIpAddr = otherAddr.toInt();

    // Instances

    IcmpApplicationAdaptor masterApplAdap = 
      new IcmpApplicationAdaptor();
    Icmp icmpProtocol =
      new Icmp();
    IcmpBounceAdaptor bounAdap =
      new IcmpBounceAdaptor();

    try {
      masterApplAdap.getSide(Side.A).attach(icmpProtocol.getSide(Side.B));
      icmpProtocol.getSide(Side.B).attach(masterApplAdap.getSide(Side.A));
      bounAdap.getSide(Side.A).attach(icmpProtocol.getSide(Side.A));
      icmpProtocol.getSide(Side.A).attach(bounAdap.getSide(Side.A));
    } catch (SideException e) {
      System.out.println("Host #" + " failed to initialize");
      System.exit(2);
    }

    IcmpApplicationAdaptor workerApplAdap =
      masterApplAdap.connect();
    if (workerApplAdap == null ) {
      System.err.println("Unable to connect to Icmp Protocol");
      System.exit(1);
    }

    int seq;
    for (int i = 1; i < 2; i++) {  // ping 5 times, for now
      seq = i;
      System.out.println("Sending ICMP Echo, seq = " + seq);
      workerApplAdap.send(otherIpAddr, seq);
      Thread.currentThread().yield();
      try {
	Thread.sleep(1000);
      } catch (InterruptedException e){ 
	// do nothing.
      }
    }

  }
}







