/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  OrderedStorage
  Package: utility
  File:    OrderedStorage.java
*/
package fi.hut.tcm.jacob.utility;
/**
  OrderedStorage
  
  The common interface of sorted storages.
*/
public interface OrderedStorage
  extends Storage {

  /**
    Removes given object from storage and returns reference to it. If item 
    doesn't found returns null.
  */
  public abstract Object take(Object item);
  
  
  
  
  /**
    Returns reference to item which have highest key (i.e. priority). 
    Returns null if storage is empty.
  */
  public abstract Object get();
  
  
  
  
} // OrderedStorage


