/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Storage
  Package: utility
  File:    Storage.java
*/
package fi.hut.tcm.jacob.utility;
/**
  Storage
  
  The common interface for fifo or lifo type of storages
*/
public interface Storage {

  /**
    Returns true if storage is full otherwise false. This method is used 
    unsynchronized. 
  */
  public abstract boolean full();
  
  
  
  
  /**
    Return true if storage is empty otherwise false.  This method is used 
    unsynchronized. 
  */
  public abstract boolean empty();
  
  
  
  
  /**
    Adds item to storage.
  */
  public abstract void put(Object item);
  
  
  
  
  /**
    Removes item from storage and returns reference to it.
  */
  public abstract Object take();
  
  
  
  
} // Storage


